<?php
/**
* dbArchive
* Create and maintain MySQL Database archives
* Copyright 2003 Amalla International. All rights reserved.
* Scott Pier - ScottBP@amalla.com
* Create Date: 03/26/2004
* Version 1.01.00
*/
require_once("preload.php");
require_once(PATH_INCLUDES . "class.export.php");
$exp = new dbdump;
require_once(PATH_INCLUDES . "phpMailer/class.phpmailer.php");
$mail = new phpmailer();
require_once(PATH_INCLUDES."inirw.class.php");
$ini = new iniRW ();
$days_to_run=CRON_DAYS;
$dbs_to_run=CRON_DBS;
$num_archives=CRON_NUM_ARCHIVES;
$day_parts=explode("|", $days_to_run);
$db_parts=explode("|", $dbs_to_run);

// Check for dbs set
if(count($db_parts)<1 || !$db_parts[0]) {
	$db_parts=array();
	$result = mysql_list_dbs();
	while ($row = mysql_fetch_assoc($result)) {
		$db_parts[]=$row['Database'];
	}
}

// Process the backups
if(count($day_parts) && in_array(date("w"), $day_parts)) {
	for($x=0; $x<count($db_parts); $x++) {
		$db_name=trim($db_parts[$x]);
		// Verify this database
		mysql_select_db($db_name);
		if(mysql_errno()){
			$report_data[]="$db_name was not archived ERROR: ".mysql_errno().": ".mysql_error();
		} else {
			// Get ini cron info
			$ini_section="DB_".strtoupper($db_name);
			$ini_info = $ini->read_section(INI_FILE, $ini_section);
			$last_arch=$ini_info['last_arch'];
			$next_arch=($last_arch>=CRON_NUM_ARCHIVES && CRON_NUM_ARCHIVES>0) ? 1 : $last_arch+1;

			// Setup Vars
			$start_time = time();
			$exp->setDB($db_name);
			$exp->setHost(DB_HOST);
			$time = time();
			$fname="{$db_name}_cron_{$next_arch}";
			$sql_file = "$fname.sql";
			$inf_file = "$fname.inf";
			$zip_file = "$fname.zip";

			// Dump .sql File
			$sql_data = $exp->getSchema();
			$fp = @fopen(PATH_ARCHIVES . $sql_file, "w");
			@fwrite ($fp, $sql_data, strlen($sql_data));
			@fclose($fp);

			// Dump .inf File
			$arc_desc="Automated backup created ".date("m/d/Y h:i a", $time);
			$inf_data = "$db_name|$time|" . base64_encode(stripslashes($arc_desc));
			$fp = @fopen(PATH_ARCHIVES . $inf_file, "w");
			@fwrite ($fp, $inf_data, strlen($inf_data));
			@fclose($fp);
			$report_data[]="$db_name was sucessfully archived completed ".date("m/d/Y h:i a", $time)."<br>
				<a href='".SITE_URL.WEB_ROOT."?action=download&id=$fname'>".SITE_URL.WEB_ROOT."?action=download&id=$fname</a>";

			// Update settings file
			$ini->write (INI_FILE, $ini_section, "last_arch" , $next_arch);
			$ini->write (INI_FILE, $ini_section, "last_arch_date" , date(DATE_MASK, $start_time));
			$ini->write (INI_FILE, $ini_section, "last_arch_time" , $start_time);
		}
	}

	// Send email
	$mail->From = "";
	$mail->FromName = SYS_PROGRAM . " Server";
	$mail->AddAddress(SITE_EMAIL, "");
	$mail->IsMail(true);
	$mail->IsHTML(true);
	$mail->Subject = "*** Automated backup report for " . date(DATE_MASK, $time);
	$smarty->assign("db_host", DB_HOST);
	$smarty->assign("report_data", $report_data);
	$smarty->assign("db_name", $db_name);
	$smarty->assign("arc_desc", stripslashes($arc_desc));
	$smarty->assign("start_time", date(DATE_MASK, $start_time));
	$smarty->assign("end_time", date(DATE_MASK, time()));
	$smarty->assign("site_url", SITE_URL);
	$email_body=EMAIL_OPEN . nl2br($smarty->fetch("cron_email.txt")) . EMAIL_CLOSE;
	$mail->Body = $email_body;
	$mail->Send();
}
?>