<?php
/**
* * Master Application Development Infrastructure (MADI) - madi@amalla.com
* Copyright 2003 Amalla International, All rights reserved.
*/
class debug {
	var $title;
	var $type;

	function debug () {
	}

	function getLogErrorTypeFromCode($code) {
		global $db;

		$code = setDefault($code);

		$sSQL = "SELECT * from " . TABLE_LOG_ERRORS_TYPES . " where " . "code like '$code'";
		$results = $db->query($sSQL);
		$rows = $results['rows'];
		if (!$rows) {
			return -1;
		}
		$ret = $results['data'][0];

		return ($db->getError($sSQL)) ? $db->getError($sSQL) : $ret;
	}

	function logError($code, $text, $detailed = 0, $send_email = 0) {
		global $db, $email, $my_account_info;

		$code = setDefault($code);
		$text = setDefault($text);
		$detailed = setDefault($detailed);
		$send_email = setDefault($send_email);

		if ($detailed) {
			$server_info = var_export($_SERVER, true);
			$request_info = var_export($_REQUEST, true);
			$session_info = var_export($_SESSION, true);
			$my_info = var_export($my_account_info, true);
			$text .= "\n\n=============================================\n";
			$text .= "=====MY_ACCOUNT_INFO=====: \n$my_info\n\n";
			$text .= "=====SERVER=====: \n$server_info\n\n";
			$text .= "=====REQUEST=====: \n$request_info\n\n";
			$text .= "=====SESSION=====: \n$session_info\n\n";
		}

		$error_type_info = $this->getLogErrorTypeFromCode($code);
		$error_type_id = 0;

		if ($error_type_info) {
			$error_type_id = $error_type_info["log_error_type_id"];
			$error_type_name = $error_type_info["name"];
		}

		$now = time();
		// Log the error
		$insert_data = array("log_error_type_id" => $error_type_id,
			"date" => $now,
			"description" => "$text"
			);
		$ret = $db->insert($insert_data, TABLE_LOG_ERRORS);

		if ($send_email) {
			$msg = array("to_email" => DEV_EMAIL,
				"to_name" => DEV_EMAIL_NAME,
				"from_email" => DEV_EMAIL,
				"from_name" => DEV_EMAIL_NAME,
				"subject" => "ERROR >> $error_type_name",
				"body" => "$text");
			$sent = $email->quickEmail($msg);
			if (!$sent) {
				$this->logError("email", "Debug Class=>logError=>Email was not sent!");
			}
		}

		return ($db->getError($sSQL)) ? $db->getError($sSQL) : $ret;
	}

	function dump($text = "", $var = "", $stop = 0, $debug_level = 0) {
		$ret['display'] = "<span style='font-family: arial; font-size: 12px; background-color: #FFFFFF; color: #00000'>\n";

		$title = "<b>$text</b>";
		$ret['title'] = $title;
		$this->title = $title;

		$var_type = gettype($var);
		$ret['var_type'] = $var_type;
		$ret['value'] = $var;
		$type = "<small><i>($var_type)</i></small>";
		$this->type = $type;
		switch ($var_type) {
			case "object":
				$ret['display'] .= "$title: Is an Object >> $type<hr>\n";
				break;
			case "boolean":
				$val = ($var == true) ? "True" : "False";
				$ret['display'] .= "$title: $val $type<hr>\n";
				break;
			case "array":
				ob_start();
				print_r($var);
				$string = ob_get_contents();
				ob_end_clean();
				$ret['display'] .= "$title<hr><pre>$string</pre>";
				break;
			case "resource":
				$ret['display'] .= "$title: Is a resource >> " . get_resource_type($var) . "<hr>\n";
				break;
			default:
				// Check for text only
				$ret['display'] .= "$title: $var\n";
				break;
		}
		// Check debug Level
		if ($debug_level > 0) {
			$ret['display'] .= $this->convertArray2Table($_SESSION, "Session Variables");
			$ret['display'] .= $this->convertArray2Table($_POST, "Post Variables");
			$ret['display'] .= $this->convertArray2Table($_GET, "Get Variables");
			$ret['display'] .= $this->convertArray2Table($_COOKIES, "Cookie Variables");
		}
		if ($debug_level >= 10) {
			$ret['display'] .= $this->convertArray2Table($_GLOBALS, "Global Variables");
			$ret['display'] .= $this->convertArray2Table($_SERVER, "Server Variables");
			$ret['display'] .= $this->convertArray2Table($_FILES, "Files Variables");
			$ret['display'] .= $this->convertArray2Table($_ENV, "Enviornment Variables");
		}
		if ($debug_level >= 50) {
			ob_start();
			phpinfo();
			$string = ob_get_contents();
			ob_end_clean();
			$ret['display'] .= $string;
		}
		// Check for stop
		if ($stop == 1) {
			$ret['display'] .= "<font color='#FF0000'><b><hr>You requested a stop</b></font><hr></span>\n";
		} else {
			$ret['display'] .= "<hr></span>\n";
		}
		return $ret;
	}
	// Convert Data Array to table
	function convertArray2Table($array, $title = "") {
		if (!$array || !is_array($array)) {
			return false;
		}
		$table = "<table width='90%' border='1' align='center' style='font-family: arial; font-size: 12px; background-color: #FFFFFF; color: #00000'>
		<tr><td colspan='4' align='center'><b>$title</b></td></tr>
		<tr align='left' valign='top'>
		<td><b>Field</b></td>
		<td><b>Value</b></td>
		<td><b>Type</b></td>
		<td><b>Len</b></td>
		</tr>\n";
		foreach ($array as $key => $val) {
			$table .= "<tr align='left' valign='top'>
			<td><b>$key</b>:</td>
			<td>$val</td>
			<td>" . gettype($val) . "</td>
			<td>" . strlen($val) . "</td>
			</tr>\n";
		}
		$table .= "</table><br><br>\n";
		return $table;
	}
}
// Wrapper functions for this class
// Developers echo / dump vars
function dump($text = "", $var = "", $stop = 0, $debug_level = 0, $force_show=0) {
	global $debug;

	if (DEV_SERVER != 1 && $force_show!=1) {
		return false;
	} else {
		$ret = $debug->dump($text, $var, $stop, $debug_level);
		echo "<table width='100%' border='0' cellpadding='0' cellspacing='0' style='background-color: #ffffff; color='#000000;'><tr><td>\n";
		echo $ret['display'];
		echo "</td></tr></table>\n";
		if ($stop == 1) {
			exit;
		}
	}
}

function dump_return($text = "", $var = "") {
	global $debug;

	$ret = $debug->dump($text, $var, 0, 0);
	$return = "<table width='100%' border='0' cellpadding='0' cellspacing='0' style='background-color: #ffffff; color='#000000;'><tr><td>\n";
	$return .= $ret['display'];
	$return .= "</td></tr></table>\n";
	return $return;
}

function logError($code, $text, $detailed = 0, $send_email = 0) {
	global $debug;

	$ret = $debug->logError($code, $text, $detailed, $send_email);
	return $ret;
}

?>
