<?php
/**
* dbArchive
* Create and maintain MySQL Database archives
* Copyright 2003 Amalla International. All rights reserved.
* Scott Pier - ScottBP@amalla.com
* Create Date: 01/03/2003
* Version 1.01.00
*/
require_once ("preload.php");
requireLogin();
if ($action == "download") {
	// Get this .sql file
	$fp = fopen(PATH_ARCHIVES . $id . ".sql", "r");
	$sql_data = fread($fp, filesize(PATH_ARCHIVES . $id . ".sql"));
	fclose($fp);
	// Check to see if we are .zip the file or .sql
	if (OPT_ZIP_SQL) {
		require_once(PATH_INCLUDES . "class.zip.php");
		$this_out_file = $id . ".zip";
		$zip = new zipfile();
		$zip->add_dir("./");
		$zip->add_file($sql_data, "./$id.sql");
		$mime_type = 'application/x-zip';
		$this_data = $zip->file();
	} else {
		$this_out_file = $id . ".sql";
		$mime_type = 'plain/text';
		$this_data = $sql_data;
	}
	// Send headers -Thanks to phpMyAdmin for this header code
	require_once(PATH_INCLUDES . "func.browser.php");
	header("Content-Type: $mime_type");
	header("Expires: " . gmdate('D, d M Y H:i:s') . " GMT");
	if (DBA_USR_BROWSER_AGENT == 'IE') {
		header('Content-Disposition: inline; filename="' . $this_out_file . '"');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
	} else {
		header('Content-Disposition: attachment; filename="' . $this_out_file . '"');
		header('Pragma: no-cache');
	}
	// Push the file
	echo $this_data;
} elseif ($action == "import") { // Import Records
	if ($confirm) {
		$file_parts = explode(".", $id);
		@mysql_select_db($file_parts[0]);
		$this_file = file(PATH_ARCHIVES . $id . ".sql");
		$table_q = array();
		$data_q = array();
		$type = "NONE";
		$tables_q = 0;
		foreach($this_file as $line_in_file) {
			$line_in_file = chop($line_in_file);
			if ($type == "NONE") {
				if (strtolower(substr($line_in_file, 0, 6)) == "insert") {
					$data_q[] = substr($line_in_file, 0, strlen($line_in_file)-1);
				} elseif (strtolower(substr($line_in_file, 0, 4)) == "drop") {
					$table_q[$tables_q] = substr($line_in_file, 0, strlen($line_in_file)-1);
					$tables_q++;
				} elseif (strtolower(substr($line_in_file, 0, 6)) == "create") {
					$type = "TABLE";
					$table_q[$tables_q] = $line_in_file . "\n";
				}
			} elseif ($type == "TABLE") {
				if (strtolower(substr($line_in_file, 0, 1)) == ")") {
					$type = "NONE";
					$table_q[$tables_q] .= substr($line_in_file, 0, strlen($line_in_file)-1) . "\n";
					$tables_q++;
				} else {
					$table_q[$tables_q] .= $line_in_file . "\n";
				}
			}
		}

		$sql_error = 0;
		// Process Table
		foreach($table_q as $q_data) {
			$q = mysql_query($q_data);
			if ($q == 0) {
				echo"<hr>";
				echo"Error: " . mysql_errno() . " - " . mysql_error() . "<br>\n";
				echo nl2br($q_data) . "\n<hr>";
				$sql_error = 1;
			}
		}
		// Process Data
		foreach($data_q as $q_data) {
			$q = mysql_query($q_data);
			if ($q == 0) {
				echo"<hr>";
				echo"Error: " . mysql_errno() . " - " . mysql_error() . "<br>\n";
				echo nl2br($q_data) . "\n<hr>";
				$sql_error = 1;
			}
		}
		// Display Results
		$this_message = '
			Archive has been imported.<br>
			<a href="?">Continue</a>
		';

		unset($action);
		unset($confirm);
		unset($id);

		$smarty->assign("page_title", "Import Archive");
		$smarty->assign("message", $this_message);
		$body=$smarty->fetch("message.htm");
		$smarty->assign("body_content", $body);
		$smarty->display("default.htm");
		exit;
	} else { // Get import Confirm
		$this_message = '
			Are you sure you wish to import this archive?<br>
			This will overwrite all existing data!<br>
			This process can\'t be undone!<br>
			Confirm [ <a href="?action=import&id=' . $id . '&confirm=yes">Yes</a> | <a href="?">No</a> ]
		';

		$smarty->assign("page_title", "Import Archive");
		$smarty->assign("message", $this_message);
		$body=$smarty->fetch("message.htm");
		$smarty->assign("body_content", $body);
		$smarty->display("default.htm");
		exit;
	}
} elseif ($action == "delete") { // Delete an archive
	if ($confirm == "yes") { // Do the delete
		$del = @unlink(PATH_ARCHIVES . $id . ".sql");
		$del = @unlink(PATH_ARCHIVES . $id . ".inf");
		$del = @unlink(PATH_ARCHIVES . $id . ".zip");

		$this_message = '
			Archive has been deleted.<br>
			<a href="?">Continue</a>
		';

		unset($action);
		unset($confirm);
		unset($id);
		$smarty->assign("page_title", "Delete Archive");
		$smarty->assign("message", $this_message);
		$body=$smarty->fetch("message.htm");
		$smarty->assign("body_content", $body);
		$smarty->display("default.htm");
		exit;
	} else { // Get delete Comfirmation
		$this_message = '
			Are you sure you wish to delete this archive?<br>
			This process can\'t be undone!<br>
			Confirm [ <a href="?action=delete&id=' . $id . '&confirm=yes">Yes</a> | <a href="?">No</a> ]
		';

		$smarty->assign("page_title", "Delete Archive");
		$smarty->assign("message", $this_message);
		$body=$smarty->fetch("message.htm");
		$smarty->assign("body_content", $body);
		$smarty->display("default.htm");
		exit;
	}
} else { // Browse Current Archives
	// Read archive directory
	require_once(PATH_INCLUDES."class.dir.php");
	$dir = new dir(PATH_ARCHIVES);
	$inf_files=$dir->LIST_get(TRUE,array('inf'));

	// Process Archives
	$arc_database=array();
	for ($x=0; $x<count($inf_files); $x++) {
		$fp = fopen($inf_files[$x], "r");
		$inf_data = fread($fp, filesize($inf_files[$x]));
		fclose($fp);
		$inf_data_parts = explode("|", $inf_data);

		// Only add new databases to database array
		if (!in_array($inf_data_parts[0], $arc_database)) {
			$arc_database[count($arc_database)]=$inf_data_parts[0];
		}

		// Build Archive name
		$arch_name_parts=explode("/", $inf_files[$x]);
		$this_id=str_replace(".inf", "", $arch_name_parts[count($arch_name_parts)-1]);

		// Build Archive array
		$this_key=array_search ($inf_data_parts[0], $arc_database);
		$this_arc_file=str_replace(".inf", ".sql", $inf_files[$x]);
		$arc_archives[$this_key][]=array(
			"id"=>$this_id,
			"date"=>date(DATE_MASK, $inf_data_parts[1]),
			"desc"=>trim(base64_decode($inf_data_parts[2])),
			"size"=>getFileSize(@filesize($this_arc_file))
		);
	}
	$smarty->assign("web_root", WEB_ROOT);
	$smarty->assign("page_title", "Browse Archives");
	$smarty->assign("arc_archives", $arc_archives);
	$smarty->assign("arc_database", $arc_database);
	$body=$smarty->fetch("browse.htm");
	$smarty->assign("body_content", $body);
	$smarty->display("default.htm");
	exit;
}
?>